diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
index 12db78c3e..1b3b32487 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
@@ -3,15 +3,16 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockTrapDoor;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicTrapDoor;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelTrapDoor(Block block) {
+public class BlockModelTrapDoor<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelTrapDoor(Block<T> block) {
         super(block);
         float offset = 0.1875F;
         withCustomItemBounds(0.0F, 0.0F, 0.0F, 1.0F, offset, 1.0F);
@@ -20,7 +21,7 @@ public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         int metadata = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        boolean isUp = BlockTrapDoor.isTrapdoorOpen(metadata);
+        boolean isUp = BlockLogicTrapDoor.isTrapdoorOpen(metadata);
 
         if(isUp) {
             switch (metadata & 3) {
@@ -54,7 +55,7 @@ public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
             }
         }
         else{
-            if(BlockTrapDoor.isUpperHalf(metadata)){
+            if(BlockLogicTrapDoor.isUpperHalf(metadata)){
                 renderBlocks.uvRotateSouth = 3;
                 renderBlocks.uvRotateNorth = 3;
                 renderBlocks.uvRotateEast = 3;
@@ -74,7 +75,7 @@ public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         int orientation = data & 3;
-        if(BlockTrapDoor.isTrapdoorOpen(data)) {
+        if(BlockLogicTrapDoor.isTrapdoorOpen(data)) {
             int index = Sides.orientationLookUpTrapdoorOpen[6 * orientation + side.getId()];
             return atlasIndices[index];
         } else {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
index 04b151c36..0a38a0ca6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
@@ -3,13 +3,14 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockTrapDoor;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicTrapDoor;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 
-public class BlockModelTrapDoorPainted<T extends Block> extends BlockModelTrapDoor<T> {
+public class BlockModelTrapDoorPainted<T extends BlockLogic> extends BlockModelTrapDoor<T> {
     public static final IconCoordinate[] topTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
     public static final IconCoordinate[] sideTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
 
@@ -19,7 +20,7 @@ public class BlockModelTrapDoorPainted<T extends Block> extends BlockModelTrapDo
             sideTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/trapdoor/planks_" + c.colorID + "/side");
         }
     }
-    public BlockModelTrapDoorPainted(Block block) {
+    public BlockModelTrapDoorPainted(Block<T> block) {
         super(block);
     }
     @Override
@@ -27,7 +28,7 @@ public class BlockModelTrapDoorPainted<T extends Block> extends BlockModelTrapDo
     {
         int color = (data >> 4) & DyeColor.MASK_COLOR;
         int orientation = data & 3;
-        if(BlockTrapDoor.isTrapdoorOpen(data)) {
+        if(BlockLogicTrapDoor.isTrapdoorOpen(data)) {
             int index = Sides.orientationLookUpTrapdoorOpen[6 * orientation + side.getId()];
             if (index < 2) return topTextures[color];
             return sideTextures[color];
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
index 58c696a32..a5877d724 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
@@ -3,20 +3,21 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockTileEntityVeryRotatable;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicVeryRotatable;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockModelVeryRotatable<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelVeryRotatable(Block block) {
+public class BlockModelVeryRotatable<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelVeryRotatable(Block<T> block) {
         super(block);
     }
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        final Direction dir = BlockTileEntityVeryRotatable.metaToDirection(meta);
+        final Direction dir = BlockLogicVeryRotatable.metaToDirection(meta);
 
         if (dir == Direction.DOWN || dir == Direction.UP) {
             renderBlocks.uvRotateSouth = 1;
@@ -41,7 +42,7 @@ public class BlockModelVeryRotatable<T extends Block> extends BlockModelStandard
     }
 
     public int getTextureIndex(Side side, int data) {
-        final Direction dir = BlockTileEntityVeryRotatable.metaToDirection(data);
+        final Direction dir = BlockLogicVeryRotatable.metaToDirection(data);
         switch (dir) { // I love brute forcing fixes so much :3
             case SOUTH:
                 return side.getId();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
index e00523025..66d69aedf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
@@ -6,15 +6,15 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockWireRedstone;
-import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicWireRedstone;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Color;
 
-public class BlockModelWireRedstone<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStandard<T> {
     protected final IconCoordinate wireStraight = TextureRegistry.getTexture("minecraft:block/wire_redstone_straight");
     protected final IconCoordinate wireCross = TextureRegistry.getTexture("minecraft:block/wire_redstone_cross");
-    public BlockModelWireRedstone(Block block) {
+    public BlockModelWireRedstone(Block<T> block) {
         super(block);
         withTextures("minecraft:block/wire_redstone_cross");
     }
@@ -38,7 +38,7 @@ public class BlockModelWireRedstone<T extends Block> extends BlockModelStandard<
             tessellator.setLightmapCoord(lmc);
         }else {
             brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-            if(Blocks.lightEmission[block.id] > 0) {
+            if(block.emission > 0) {
                 brightness = 1.0f;
             }
             brightness = Math.max(brightness, (meta & 0xF)/16f);
@@ -51,32 +51,32 @@ public class BlockModelWireRedstone<T extends Block> extends BlockModelStandard<
         float blue = color.getBlue() / 255.0f;
 
         tessellator.setColorOpaque_F(brightness * red, brightness * green, brightness * blue);
-        boolean west = BlockWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x - 1, y, z, 1) || !renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && BlockWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x - 1, y - 1, z, -1);
-        boolean east = BlockWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x + 1, y, z, 3) || !renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && BlockWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x + 1, y - 1, z, -1);
-        boolean north = BlockWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y, z - 1, 2) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && BlockWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y - 1, z - 1, -1);
-        boolean south = BlockWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y, z + 1, 0) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && BlockWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y - 1, z + 1, -1);
+        boolean west = BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x - 1, y, z, 1) || !renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x - 1, y - 1, z, -1);
+        boolean east = BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x + 1, y, z, 3) || !renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x + 1, y - 1, z, -1);
+        boolean north = BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y, z - 1, 2) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y - 1, z - 1, -1);
+        boolean south = BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y, z + 1, 0) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y - 1, z + 1, -1);
         boolean westUp = false;
         boolean eastUp = false;
         boolean northUp = false;
         boolean southUp = false;
         if(!renderBlocks.blockAccess.isBlockOpaqueCube(x, y + 1, z))
         {
-            if(renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && BlockWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x - 1, y + 1, z, -1))
+            if(renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x - 1, y + 1, z, -1))
             {
                 west = true;
                 westUp = true;
             }
-            if(renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && BlockWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x + 1, y + 1, z, -1))
+            if(renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x + 1, y + 1, z, -1))
             {
                 east = true;
                 eastUp = true;
             }
-            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && BlockWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y + 1, z - 1, -1))
+            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y + 1, z - 1, -1))
             {
                 north = true;
                 northUp = true;
             }
-            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && BlockWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y + 1, z + 1, -1))
+            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y + 1, z + 1, -1))
             {
                 south = true;
                 southUp = true;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWool.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWool.java
index f450baf72..6059031e9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWool.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWool.java
@@ -3,10 +3,11 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelWool<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelWool<T extends BlockLogic> extends BlockModelStandard<T> {
     public static final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
 
     static {
@@ -14,7 +15,7 @@ public class BlockModelWool<T extends Block> extends BlockModelStandard<T> {
             texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/wool/" + c.colorID);
         }
     }
-    public BlockModelWool(Block block) {
+    public BlockModelWool(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlag.java b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlag.java
index fc3918ab9..e157aa28c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlag.java
+++ b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlag.java
@@ -29,7 +29,7 @@ public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag>
     public void doRender(Tessellator tessellator, TileEntityFlag tileEntity, double x, double y, double z, float partialTick) {
         World theWorld = Minecraft.getMinecraft().currentWorld;
         int blockUnder = theWorld.getBlockId(tileEntity.x, tileEntity.y - 1, tileEntity.z);
-        boolean shortPole = blockUnder == Blocks.FLAG.id;
+        boolean shortPole = blockUnder == Blocks.FLAG.id();
 
         WindProvider theWind = mc.currentWorld.getWorldType().getWindManager();
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java
index 08127f80e..e14d148ce 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java
@@ -29,7 +29,7 @@ public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFl
     @Override
     public void doRender(Tessellator tessellator, TileEntityFlowerJar tileEntity, double x, double y, double z, float renderPartialTicks) {
         GL11.glPushMatrix();
-        Block block = Blocks.getBlock(tileEntity.flowerInPot);
+        Block<?> block = Blocks.getBlock(tileEntity.flowerInPot);
         if(block != null){
             GL11.glTranslatef((float)x, (float)y, (float)z);
             TextureRegistry.blockAtlas.bind();
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java
index bd31230a2..12cbe6d64 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java
@@ -13,10 +13,9 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.piston.BlockPistonBase;
+import net.minecraft.core.block.piston.BlockLogicPistonBaseSteel;
+import net.minecraft.core.block.piston.BlockLogicPistonHead;
 import net.minecraft.core.block.piston.TileEntityMovingPistonBlock;
-import net.minecraft.core.block.piston.BlockPistonHead;
-import net.minecraft.core.block.piston.BlockPistonBaseSteel;
 import net.minecraft.core.world.BlocksContainer;
 import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
@@ -44,7 +43,7 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
 	public void doRender(Tessellator tessellator, TileEntityMovingPistonBlock blockEntity, double x, double y, double z,
                          float partialTick)
     {
-        Block block = Blocks.blocksList[blockEntity.getMovedId()];
+        Block<?> block = Blocks.getBlock(blockEntity.getMovedId());
         if(block != null && blockEntity.getProgress(partialTick) < 1.0F)
         {
             if (container == null || container.world != blockEntity.worldObj) {
@@ -65,24 +64,24 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
             }
             tessellator.startDrawingQuads();
             tessellator.setTranslation(((float)x - (float)blockEntity.x) + blockEntity.getXOff(partialTick), ((float)y - (float)blockEntity.y) + blockEntity.getYOff(partialTick), ((float)z - (float)blockEntity.z) + blockEntity.getZOff(partialTick));
-            if(block instanceof BlockPistonHead && blockEntity.getProgress(partialTick) < 0.5F)
+            if(Block.hasLogicClass(block, BlockLogicPistonHead.class) && blockEntity.getProgress(partialTick) < 0.5F)
             {
                 BlockModel.setRenderBlocks(renderBlocks);
-                ((BlockModelPistonHead)BlockModelDispatcher.getInstance().getDispatch(block)).renderPistonHeadNoCulling(tessellator, (BlockPistonHead) block, blockEntity.x, blockEntity.y, blockEntity.z, false);
+                ((BlockModelPistonHead)BlockModelDispatcher.getInstance().getDispatch(block)).renderPistonHeadNoCulling(tessellator, (Block<BlockLogicPistonHead>) block, blockEntity.x, blockEntity.y, blockEntity.z, false);
             } else
             if(blockEntity.isSourcePiston() && !blockEntity.isExtending())
             {
-                BlockModelPiston<BlockPistonBase> pistonBase = (BlockModelPiston) BlockModelDispatcher.getInstance().getDispatch(block);
+                BlockModelPiston<?> pistonBase = (BlockModelPiston<?>) BlockModelDispatcher.getInstance().getDispatch(block);
                 BlockModel.setRenderBlocks(renderBlocks);
-                if (block instanceof BlockPistonBaseSteel) { // Todo remove this terrible hardcoded render code
+                if (Block.hasLogicClass(block, BlockLogicPistonBaseSteel.class)) { // Todo remove this terrible hardcoded render code
                     BlockModelPistonHead blockModelPistonHead = ((BlockModelPistonHead) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD_STEEL));
                     blockModelPistonHead.setFaceTextureOverride(pistonBase.getFaceTexture());
-                    blockModelPistonHead.renderPistonHeadNoCulling(tessellator, (BlockPistonHead) Blocks.PISTON_HEAD_STEEL, blockEntity.x, blockEntity.y, blockEntity.z, blockEntity.getProgress(partialTick) < 0.5F);
+                    blockModelPistonHead.renderPistonHeadNoCulling(tessellator, Blocks.PISTON_HEAD_STEEL, blockEntity.x, blockEntity.y, blockEntity.z, blockEntity.getProgress(partialTick) < 0.5F);
                     blockModelPistonHead.setFaceTextureOverride(null);
                 } else {
                     BlockModelPistonHead blockModelPistonHead = ((BlockModelPistonHead) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD));
                     blockModelPistonHead.setFaceTextureOverride(pistonBase.getFaceTexture());
-                    blockModelPistonHead.renderPistonHeadNoCulling(tessellator, (BlockPistonHead) Blocks.PISTON_HEAD, blockEntity.x, blockEntity.y, blockEntity.z, blockEntity.getProgress(partialTick) < 0.5F);
+                    blockModelPistonHead.renderPistonHeadNoCulling(tessellator, Blocks.PISTON_HEAD, blockEntity.x, blockEntity.y, blockEntity.z, blockEntity.getProgress(partialTick) < 0.5F);
                     blockModelPistonHead.setFaceTextureOverride(null);
                 }
                 tessellator.setTranslation((float)x - (float)blockEntity.x, (float)y - (float)blockEntity.y, (float)z - (float)blockEntity.z);
@@ -90,8 +89,8 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
             } else
             {
                 BlockModel.setRenderBlocks(containerRenderBlock);
-                container.setBlock(blockEntity.x, blockEntity.y, blockEntity.z, block.id, blockEntity.getMovedData(), blockEntity.getMovedEntity());
-                BlockModelDispatcher.getInstance().getDispatch(block).renderNoCulling(Tessellator.instance, blockEntity.x, blockEntity.y, blockEntity.z);
+                container.setBlock(blockEntity.x, blockEntity.y, blockEntity.z, block.id(), blockEntity.getMovedData(), blockEntity.getMovedEntity());
+                BlockModelDispatcher.getInstance().getDispatch(block).renderNoCulling(tessellator, blockEntity.x, blockEntity.y, blockEntity.z);
                 container.setLightReferenceEntity(null);
                 container.clear();
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java
index ba93ed529..519558e45 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java
@@ -28,7 +28,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
     public void renderTileEntitySignAt(TileEntitySign tileEntity, double d, double d1, double d2,
                                        float f)
     {
-        Block block = tileEntity.getBlock();
+        Block<?> block = tileEntity.getBlock();
         GL11.glPushMatrix();
         float scale = 0.6666667F;
         if(block == Blocks.SIGN_POST_PLANKS_OAK)
diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/CameraUtil.java b/game/client/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
index 276710b8c..2fd36b3db 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
@@ -1,9 +1,8 @@
 package net.minecraft.client.render.camera;
 
-import net.minecraft.core.block.BlockFluid;
+import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
@@ -26,9 +25,9 @@ public abstract class CameraUtil
         int y = MathHelper.floor_float(MathHelper.floor(cameraY));
         int z = MathHelper.floor(camera.getZ(partialTick));
         int id = world.getBlockId(x, y, z);
-        if(id != 0 && Blocks.blocksList[id].blockMaterial == material)
+        if(id != 0 && Blocks.blocksList[id].getMaterial() == material)
         {
-            float f = BlockFluid.getWaterVolume(world.getBlockMetadata(x, y, z)) - 0.2F;
+            float f = BlockLogicFluid.getWaterVolume(world.getBlockMetadata(x, y, z)) - 0.2F;
             float f1 = (float)(y + 1) - f;
             return cameraY < (double)f1;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index 64d21cf63..5a4dd0935 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -147,7 +147,7 @@ public abstract class EntityRenderer<T extends Entity>
         return renderDispatcher.world;
     }
 
-    private void renderShadowOnBlock(Tessellator tessellator, T entity, Block block, double d, double d1, double d2,
+    private void renderShadowOnBlock(Tessellator tessellator, T entity, Block<?> block, double d, double d1, double d2,
                                      int x, int y, int z, float opacity, float size, double xo,
                                      double yo, double zo)
     {
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
index c25847e04..589409b52 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
@@ -13,7 +13,6 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.EntityFallingBlock;
 import net.minecraft.core.world.BlocksContainer;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
index 5ed089652..c1e070110 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
@@ -36,7 +36,7 @@ public class EntityRendererItem extends EntityRenderer<EntityItem>
 
 	public int getItemColorFromMetadata(Item item, int metadata) {
 		if (item instanceof ItemBlock) {
-			Block block = ((ItemBlock)item).getBlock();
+			Block<?> block = ((ItemBlock<?>)item).getBlock();
 			return BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
 		}
 		return 0xFFFFFF;
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
index ad83e5d58..91b94b718 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
@@ -97,7 +97,7 @@ public class EntityRendererMinecart extends EntityRenderer<MinecartEntity> {
             }
             switch (minecart.type){
                 case MinecartEntity.CHEST_CART:
-                    Block block;
+                    Block<?> block;
                     if ((minecart.typeMeta & 0b0000_0001) != 0) {
                         block = Blocks.CHEST_PLANKS_OAK_PAINTED;
                     } else {
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
index 49a9c7666..a97975654 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
@@ -23,11 +23,11 @@ public class EntityRendererSprite<T extends Entity> extends EntityRenderer<T>
         itemIconIndex = i;
     }
 
-    public EntityRendererSprite setFullBright(){
+    public EntityRendererSprite<T> setFullBright(){
         fullBright = true;
         return this;
     }
-    public EntityRendererSprite setScale(float scale){
+    public EntityRendererSprite<T> setScale(float scale){
         this.scale = scale;
         return this;
     }
